#ifndef GETUSERS_H_
#define GETUSERS_H_

/* stupid linux systems need this */
#define _GNU_SOURCE

#include <sys/types.h>

#include <stdarg.h>

#include "config.h"

#define STYPE_UNKNOWN  0x000000
#define STYPE_HYBRID   0x000001
#define STYPE_COMSTUD  0x000002
#define STYPE_BAHAMUT  0x000004
#define STYPE_CS       0x000008
#define STYPE_2_8      0x000010
#define STYPE_2_9      0x000020
#define STYPE_2_10     0x000040
#define STYPE_ELITE    0x000080
#define STYPE_UNREAL   0x000100
#define STYPE_NEWNET   0x000200
#define STYPE_CHATNET  0x000400
#define STYPE_ULTIMATE 0x000800
#define STYPE_BEYOND   0x001000
#define STYPE_AUSTHEX  0x002000
#define STYPE_XNET     0x004000
#define STYPE_GLX      0x008000
#define STYPE_CR       0x010000
#define STYPE_RELIC    0x020000
#define STYPE_DAL      0x040000
#define STYPE_SOR      0x080000
#define STYPE_IRCU     0x100000

#define ULTIMATE_FORMAT 0x01
#define HYBRID_FORMAT   0x02
#define IRC28_FORMAT    0x04
#define IRC29_FORMAT    0x08
#define SWAP_OUTPUT     0x10

#define IRC28_LOCAL  0x40000000
#define IRC28_GLOBAL 0x80000000

#define MAX_ARG 64
#define MAX_STRING 256

struct config_s {
	char *server;
	char *target;
	char *vhost;
	char *opernick;
	char *operpass;
	int oper;
	int port;
	int mrtg;
	int lo;
	int go;
};

struct wait_tab {
	char *numeric;
	char *result;
};

struct server_reply {
	int argc;
	char **argv;
};

extern struct config_s config;

int   sock_connect(char *, int, char *);
int   find_version(struct server_reply *);
int   irc_readbyte(int);
int   create_vector(int *, char *[MAX_ARG], char *);
int   create_raw_vector(int *, char *[MAX_ARG], char *);
int   parse_config(char *);
void  sock_send(int, char *, ...);
void  format_lusers(struct server_reply *, int mflag, char **, int);
void  free_vector(char **, int);
char *sock_read_line(int);

#ifdef NO_SNPRINTF
int   snprintf(char *, size_t, char *, ...);
#endif

#ifdef NO_ASPRINTF
int   asprintf(char **, char *, ...);
#endif

#ifdef NO_STRSEP
char *strsep(char **, char *);
#endif

struct server_reply *wait_numeric(int, struct wait_tab *);
struct server_reply *wait_single_numeric(int, char *, char *);

#endif
